{*******************************************************}
{                                                       }
{       RichView                                        }
{       Demo: switching to overtype mode.               }
{                                                       }
{       Copyright (c) Sergey Tkachenko                  }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, ComCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RichViewEdit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FInsertMode: Boolean;
    FIgnoreNextChar: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  KeyPreview := True;
  FInsertMode := True;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const KeyMode: array[Boolean] of String = ('OVERTYPE', 'INSERT');
begin
  if (Key=VK_INSERT) and (Shift=[]) then begin
    FInsertMode := not FInsertMode;
    StatusBar1.SimpleText := KeyMode[FInsertMode];
  end;
end;

procedure TForm1.RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  FIgnoreNextChar := not FInsertMode and RichViewEdit1.SelectionExists;
end;

procedure TForm1.RichViewEdit1KeyPress(Sender: TObject; var Key: Char);
var ItemNo, Offs: Integer;
    rve: TCustomRichViewEdit;
begin
  if FInsertMode or FIgnoreNextChar then begin
    FIgnoreNextChar := False;
    exit;
  end;
  FIgnoreNextChar := False;
  if not ((Key=#9) or (Key>=' ')) then
    exit;
  rve := RichViewEdit1.TopLevelEditor;
  if rve.SelectionExists then
    exit;
  ItemNo := rve.CurItemNo;
  Offs  := rve.OffsetInCurItem;
  if (Offs>=rve.GetOffsAfterItem(ItemNo)) then begin
    if (ItemNo+1<rve.ItemCount) and
       not rve.IsFromNewLine(ItemNo+1) then begin
      inc(ItemNo);
      Offs := rve.GetOffsBeforeItem(ItemNo);
      end
    else
      exit;
  end;
  rve.SetSelectionBounds(ItemNo, Offs, ItemNo, Offs+1);
  rve.Invalidate;
end;

end.
